#define NUMTELS 6
#define BASELINES 6
#define NUMDLS 6

/* modtrig commands */
#define MODTRIG_START   0
#define MODTRIG_STOP    1
#define MODTRIG_RESET   2


/* Big structure used for python configuration AND for 
   sending info to the Spooler */

#ifndef __BOOLEAN__
#define __BOOLEAN__
enum BOOL {FALSE, TRUE};
typedef enum BOOL boolean;
#endif

/** Spooler messages*/
enum {
  HEADER,
  DATA,
  END,
  KILL
};
/* This structure is used to communicate data to 
   the python interface and with the spooler */
struct pythonconfig {
  int NTels;
  int BeamOrder[NUMTELS];
  int RefTel;
  int WrapBeam;
  unsigned int FiberExplorerX[NUMTELS];
  unsigned int FiberExplorerY[NUMTELS];
  float lambda;
  float bandwidth;
  float gdtThreshold[BASELINES];  //should really be in the gdt structure!
  float gdtGain;
  unsigned char cpeak[BASELINES];
  unsigned char cpeak0[BASELINES];
  unsigned char cpeak1[BASELINES];
  unsigned char bkgndNoiseCol;
  char fileDescription[30];
  char MircFilter1[30];
  char MircFilter2[30];
  char ConfigName[30]; 
  char TelKey[30];
  char observer[30];
  char comment1[30];
  char comment2[30];
};
typedef struct pythonconfig pythonconfig_struct;

struct theGDT {
  double dlOffsets[NUMDLS];
  double manualOffset[NUMDLS];
  boolean activeBaselines[BASELINES];
  boolean gdtLock[BASELINES];
  boolean continuousReadout;
};
typedef struct theGDT gdt_struct;

struct theHeader {
  unsigned long numberOfFrames;
  unsigned short rows;
  unsigned short cols;
  unsigned short rowOffset;
  unsigned short colOffset;  
  unsigned short nreads;
  unsigned short numberOfCoadds;
  unsigned short framesPerReset;
  unsigned short savesPerFile;
  unsigned short exptime;
  float voffset;
  float vreset;  
  float vd;
  float ictl;
  float tint;
  unsigned char do_image_save;
  char image_directory[30];
  pythonconfig_struct  pyconfig;
  gdt_struct gdt;
  double dloffsets[NUMDLS];
 };

typedef struct theHeader header_struct;

struct theftData {
   float dither_freq; 
   float dither_amp; 
   float opdamp;
   float dither_smoothfrac;
   float dither_delay;
   boolean active[6];
   float offset[6];
   float gain[6];
   int   search_state[6]; // set up as enum.. 0 = no, 1=linear, 2=spiral
   float search_step[6];  // shift in microns per sawtooch
   float search_threshold[6]; // stop search if Amp is above this and turn on ftrack..
};

typedef struct theftData ft_struct;


